package com.sf.web.dms.faultlist.control;

package ..deTemp.1731583219781;

import com.sf.web.dms.faultlist.bean.FaultAutoCheckQueryParaVO;
import com.sf.web.dms.faultlist.bean.FaultInfoManualQueryParaVO;
import com.sf.web.dms.faultlist.bean.FaultInfoQueryParaVO;
import com.sf.web.dms.faultlist.entity.DaFaultInfo;
import com.sf.web.dms.faultlist.service.MyDaFaultInfoService;
import com.sf.web.dms.faultlist.service.MyFaultEventService;
import com.sf.web.dms.util.ListUtil;
import com.smartframework.core.annotation.SmartComment;
import com.smartframework.core.annotation.SmartNoSecurityFilter;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.i18n.I18n;
import com.smartframework.core.smart.SmartView;
import com.smartframework.web.core.Constants;
import com.smartframework.web.core.bean.HeaderConfig;
import com.smartframework.web.core.control.BasicControl;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.DateUtil;
import com.smartframework.web.core.util.ExcelDataUtil;
import com.smartframework.web.core.util.JsonUtil;
import com.smartframework.web.core.util.ParameterUtils;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@SmartComment("DaFaultInfo实例增删改查接口层")
public class MyDaFaultInfoControl extends BasicControl {
  private MyDaFaultInfoService myDaFaultInfoService;
  
  private MyFaultEventService myFaultEventService;
  
  public MyDaFaultInfoService getMyDaFaultInfoService() {
    return this.myDaFaultInfoService;
  }
  
  public void setMyDaFaultInfoService(MyDaFaultInfoService myDaFaultInfoService) {
    this.myDaFaultInfoService = myDaFaultInfoService;
  }
  
  public MyFaultEventService getMyFaultEventService() {
    return this.myFaultEventService;
  }
  
  public void setMyFaultEventService(MyFaultEventService myFaultEventService) {
    this.myFaultEventService = myFaultEventService;
  }
  
  @SmartComment("保存DaFaultInfo实例")
  public SmartView save(DaFaultInfo daFaultInfo) {
    return dbAccess(this.myDaFaultInfoService.save(daFaultInfo));
  }
  
  @SmartComment("按ID列表删除DaFaultInfo对象")
  public SmartView delete(List<Integer> ids) {
    return dbAccess(this.myDaFaultInfoService.delete(ids, false));
  }
  
  @SmartComment("按ID列表彻底删除DaFaultInfo对象")
  public SmartView deletePermanently(List<Integer> ids) {
    return dbAccess(this.myDaFaultInfoService.delete(ids, false));
  }
  
  @SmartComment("按ID获取单个DaFaultInfo实例")
  public SmartView loadOne(Integer id) {
    return SmartView.SUCCESS(this.myDaFaultInfoService.get(id));
  }
  
  public SmartView loadFaultInfoHistoryTotal(FaultInfoQueryParaVO paraVO) {
    if (!ParameterUtils.isEmptyOrNull(paraVO.getStartTime()) && !ParameterUtils.isEmptyOrNull(paraVO.getEndTime())) {
      List<Map<String, Object>> faultDataInfo = this.myDaFaultInfoService.getfaultInfoHistoryTotalByQuery(paraVO);
      PagingBean page = new PagingBean(0, 0);
      int totalNumAll = faultDataInfo.size();
      page.setTotalItems(totalNumAll);
      page.setData(faultDataInfo);
      return pageView(page);
    } 
    return SmartView.ERROR(I18n.message("error.parametertime.empty", "起始时间或者结束时间不能为空", new Object[] { "startTime,endTime" }));
  }
  
  public SmartView loadFaultInfoHistory(FaultInfoQueryParaVO paraVO) {
    if (!ParameterUtils.isEmptyOrNull(paraVO.getStartTime()) && !ParameterUtils.isEmptyOrNull(paraVO.getEndTime())) {
      PagingBean page = this.myDaFaultInfoService.getfaultInfoHistoryByQuery(paraVO);
      List<Map<String, Object>> data = page.getData();
      List<Object> daFaultIdvector = new ArrayList();
      Map<Object, List<Map<String, Object>>> mapDaFaultInfoDesc = new HashMap<>();
      for (Map<String, Object> m : (Iterable<Map<String, Object>>)page.getData()) {
        List<Map<String, Object>> faultvector = (List<Map<String, Object>>)m.get("faultinfolist");
        daFaultIdvector.add(m.get("id"));
        mapDaFaultInfoDesc.put(m.get("id"), faultvector);
      } 
      for (int i = 0; i < data.size(); i++) {
        Map<String, Object> tgAveObj = data.get(i);
        Object devId = tgAveObj.get("id");
        if (!daFaultIdvector.contains(devId)) {
          daFaultIdvector.add(devId);
          List<Map<String, Object>> myInfo = new ArrayList<>();
          myInfo.add(tgAveObj);
          mapDaFaultInfoDesc.put(devId, myInfo);
        } else {
          List<Map<String, Object>> myInfo = mapDaFaultInfoDesc.get(devId);
          myInfo.add(tgAveObj);
          mapDaFaultInfoDesc.put(devId, myInfo);
        } 
      } 
      List<Object> faultInfoID = new ArrayList();
      List<Map<String, Object>> faultDataInfoDesc = new ArrayList<>();
      int j;
      for (j = 0; j < daFaultIdvector.size(); j++) {
        Object key = daFaultIdvector.get(j);
        Map<String, Object> faultobj = new HashMap<>();
        List<Map<String, Object>> objInfo = mapDaFaultInfoDesc.get(key);
        Map<String, Object> faultInfoDesc = objInfo.get(0);
        if (faultInfoDesc.size() > 3) {
          faultobj.put("id", faultInfoDesc.get("id"));
          faultInfoID.add(faultInfoDesc.get("id"));
          faultobj.put("feederName", faultInfoDesc.get("feederName"));
          faultobj.put("graphName", faultInfoDesc.get("graphName"));
          faultobj.put("feederId", faultInfoDesc.get("feederId"));
          faultobj.put("stationName", faultInfoDesc.get("stationName"));
          faultobj.put("breakerName", faultInfoDesc.get("breakerDescription"));
          faultobj.put("tripBreakerName", faultInfoDesc.get("tripBreakerName"));
          faultobj.put("tripContainer", faultInfoDesc.get("tripContainer"));
          faultobj.put("tripConName", faultInfoDesc.get("tripConName"));
          faultobj.put("startCond", faultInfoDesc.get("startCond"));
          faultobj.put("daStatus", faultInfoDesc.get("daStatus"));
          faultobj.put("faultMode", faultInfoDesc.get("faultMode"));
          faultobj.put("faultTime", faultInfoDesc.get("faultTime"));
          faultobj.put("daStatusDesc", faultInfoDesc.get("daStatusDesc"));
          faultobj.put("faultModeDesc", faultInfoDesc.get("faultModeDesc"));
          faultobj.put("configMode", faultInfoDesc.get("configMode"));
          faultobj.put("configModeValue", faultInfoDesc.get("configModeValue"));
          faultobj.put("recloseResult", faultInfoDesc.get("recloseResult"));
          faultobj.put("daRecloseResult", faultInfoDesc.get("daRecloseResult"));
          faultobj.put("isFault", faultInfoDesc.get("isFault"));
          faultobj.put("faultReason", faultInfoDesc.get("faultReason"));
          faultobj.put("realborderdevId", faultInfoDesc.get("realborderdevId"));
          faultobj.put("faresultFlag", faultInfoDesc.get("faresultFlag"));
          String condName = loadDaStartCondDesc(faultInfoDesc.get("startCond"));
          faultobj.put("startCondDesc", condName);
          faultobj.put("commentType", faultInfoDesc.get("commentType"));
          faultobj.put("resultIntvalue", faultInfoDesc.get("resultIntvalue"));
          faultobj.put("comMsg", faultInfoDesc.get("comMsg"));
          faultobj.put("areaDesc", faultInfoDesc.get("areaDescription"));
          faultobj.put("areaResp", faultInfoDesc.get("areaResp"));
          faultobj.put("reduceNum", faultInfoDesc.get("reduceNum"));
          faultobj.put("reduceHournum", faultInfoDesc.get("reduceHournum"));
          faultobj.put("daExecDesc", faultInfoDesc.get("execResult"));
          faultobj.put("feederObjType", faultInfoDesc.get("feederObjType"));
          String content = "";
          if (!ParameterUtils.isEmptyOrNull(faultInfoDesc.get("content")))
            content = faultInfoDesc.get("content").toString().replace("$[", "").replace("]$", ""); 
          faultobj.put("modChangeContent", content);
          faultobj.put("influenceFeederName", "");
          faultobj.put("influenceFeederId", "");
          faultobj.put("influenceGraphName", "");
          StringBuilder descInfo = new StringBuilder("");
          List<Object> faultTypeInfo = new ArrayList();
          List<Object> daFaultAreaIdvector = new ArrayList();
          Map<Object, StringBuilder> mapInfoDescription = new HashMap<>();
          for (int k = 0; k < objInfo.size(); k++) {
            Map<String, Object> faultInfoDesc1 = objInfo.get(k);
            Object areaId = faultInfoDesc1.get("faultAreaId");
            if (!ParameterUtils.isEmptyOrNull(areaId)) {
              String feederName = this.myDaFaultInfoService.getFeederNameByAreaId(areaId.toString());
              if (!feederName.equals(faultobj.get("feederName")))
                faultobj.replace("influenceFeederName", feederName); 
              faultInfoDesc1.replace("feederName", feederName);
              Map<String, Object> influenceFeederMap = this.myDaFaultInfoService.getFeederMapByAreaId(areaId.toString());
              String feederId = new String();
              if (!ParameterUtils.isEmptyOrNull(faultobj.get("feederId")))
                feederId = faultobj.get("feederId").toString(); 
              String graphName = new String();
              if (!ParameterUtils.isEmptyOrNull(faultobj.get("graphName")))
                graphName = faultobj.get("graphName").toString(); 
              for (String influenceFeederId : influenceFeederMap.keySet()) {
                if (!influenceFeederId.equals(feederId))
                  faultobj.replace("influenceFeederId", influenceFeederId); 
                String influenceGraphName = new String();
                if (!ParameterUtils.isEmptyOrNull(influenceFeederMap.get(influenceFeederId)))
                  influenceGraphName = influenceFeederMap.get(influenceFeederId).toString(); 
                if (!influenceGraphName.equals(graphName))
                  faultobj.replace("influenceGraphName", influenceGraphName); 
              } 
              String areaDesc = String.valueOf(faultInfoDesc1.get("faultAreaDescription"));
              String boardDevDesc = String.valueOf(faultInfoDesc1.get("boarddevId"));
              String[] boradDevListst = boardDevDesc.split(";");
              List<String> boradDevList = Arrays.asList(boradDevListst);
              List<Long> vectorBoardId = new ArrayList<>();
              int nVaildName = 0;
              for (int m = 0; m < boradDevList.size(); m++) {
                if (!ParameterUtils.isEmptyOrNull(boradDevList.get(m))) {
                  String obj = boradDevList.get(m);
                  if (ParameterUtils.isNumeric(obj)) {
                    Long boardLongId = Long.valueOf(Long.parseLong(obj));
                    vectorBoardId.add(boardLongId);
                  } 
                } 
              } 
              Integer pageIndex1 = Integer.valueOf(1);
              Integer pageSize1 = Integer.valueOf(-1);
              String boardDescription = descByQueryIdList(vectorBoardId, pageIndex1, pageSize1);
              String busbarFaultDesc = queryBusbarFault(Long.valueOf(faultobj.get("id").toString()));
              if ("1".equals(Constants.getString("dms.fa.list.showbusbar", "0")) && 
                !ParameterUtils.isEmptyOrNull(busbarFaultDesc))
                boardDescription = busbarFaultDesc; 
              Object breakerNameDesc = faultInfoDesc1.get("tripBreakerName");
              if (!ParameterUtils.isEmptyOrNull(faultInfoDesc1.get("tripBreakerId")))
                breakerNameDesc = getDevNameWithFather(faultInfoDesc1.get("tripBreakerId").toString()); 
              if (ParameterUtils.isEmptyOrNull(breakerNameDesc))
                breakerNameDesc = "无开关"; 
              if (!daFaultAreaIdvector.contains(areaId)) {
                daFaultAreaIdvector.add(areaId);
                Object faultTypeobj = faultInfoDesc.get("faultType");
                if (!ParameterUtils.isEmptyOrNull(faultTypeobj)) {
                  List<Integer> faultTypeVector = loadfaultDesc(faultTypeobj);
                  for (int mm = 0; mm < faultTypeVector.size(); mm++)
                    faultTypeInfo.add(faultTypeVector.get(mm)); 
                } else {
                  faultTypeInfo.add(Integer.valueOf(-1));
                } 
                if (faultTypeInfo.size() == 0)
                  faultTypeInfo.add(Integer.valueOf(-1)); 
                StringBuilder objDescription = new StringBuilder("");
                objDescription.append(faultInfoDesc1.get("feederName"));
                objDescription.append(" ");
                objDescription.append("位于");
                objDescription.append(boardDescription);
                objDescription.append("发生");
                objDescription.append(" ");
                String faultTypeDesc = "";
                if (faultTypeInfo.size() == 0) {
                  faultTypeDesc = "正常";
                } else {
                  faultTypeDesc = loadDaFaultTypeDesc(faultTypeInfo);
                } 
                objDescription.append(faultTypeDesc);
                objDescription.append("导致" + breakerNameDesc + "跳闸");
                mapInfoDescription.put(areaId, objDescription);
              } else {
                StringBuilder objDescription = mapInfoDescription.get(areaId);
                objDescription.append("   与" + breakerNameDesc + "跳闸");
                mapInfoDescription.put(areaId, objDescription);
              } 
            } 
          } 
          for (Object mm : mapInfoDescription.keySet()) {
            StringBuilder objInfoDesc = mapInfoDescription.get(mm);
            objInfoDesc.append("      ");
            descInfo.append(objInfoDesc);
          } 
          descInfo.toString();
          faultobj.put("boarddevDesc", descInfo);
          faultobj.put("faultType", faultTypeInfo);
          if (ParameterUtils.isEmptyOrNull(paraVO.getOperTargetList())) {
            faultDataInfoDesc.add(faultobj);
          } else if ("1".equals(loadDaOperTarget(faultInfoDesc.get("operTarget"), paraVO.getOperTargetList()))) {
            faultDataInfoDesc.add(faultobj);
          } 
        } 
      } 
      for (j = 0; j < faultDataInfoDesc.size(); j++) {
        Map<String, Object> dataOutDescobj = faultDataInfoDesc.get(j);
        Object faultTypeNum = dataOutDescobj.get("faultType");
        String daRecloseResultWx = "";
        String tripContainer = String.valueOf(dataOutDescobj.get("tripContainer"));
        String tripBreakerName = String.valueOf(dataOutDescobj.get("tripBreakerName"));
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("daRecloseResult")))
          daRecloseResultWx = dataOutDescobj.get("daRecloseResult").toString(); 
        if (!tripContainer.equals("con_voltagelevel"))
          daRecloseResultWx = "分级保护"; 
        if (tripContainer.equals("con_compositeswitch")) {
          String tripConName = dataOutDescobj.get("tripConName").toString();
          tripBreakerName = tripConName + "." + tripBreakerName;
        } 
        dataOutDescobj.put("daRecloseResultWx", daRecloseResultWx);
        dataOutDescobj.put("tripBreakerName", tripBreakerName);
        String faultTypeDesc = "正常";
        String isFaultDesc = "";
        String faresultFlagDesc = "";
        String realborderdevIdDesc = "";
        faultTypeDesc = loadDaFaultTypeDesc(faultTypeNum);
        Integer resultIntvalue = Integer.valueOf(0);
        Integer commentType = null;
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("resultIntvalue")))
          resultIntvalue = Integer.valueOf(dataOutDescobj.get("resultIntvalue").toString()); 
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("commentType")))
          commentType = Integer.valueOf(dataOutDescobj.get("commentType").toString()); 
        String resultType = "暂无";
        if (faultTypeDesc == "")
          faultTypeDesc = "正常"; 
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("faresultFlag"))) {
          Integer faresultFlag = Integer.valueOf(dataOutDescobj.get("faresultFlag").toString());
          if (faresultFlag.intValue() == -1) {
            faresultFlagDesc = "比较失败";
          } else if (faresultFlag.intValue() == 0) {
            faresultFlagDesc = "未比较";
          } else if (faresultFlag.intValue() == 1) {
            faresultFlagDesc = "定位结果一致";
          } else if (faresultFlag.intValue() == 2) {
            faresultFlagDesc = "定位结果不一致";
          } 
        } 
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("isFault"))) {
          Integer isFault = Integer.valueOf(dataOutDescobj.get("isFault").toString());
          if (isFault.intValue() == -1) {
            isFaultDesc = "否";
          } else if (isFault.intValue() == 1) {
            isFaultDesc = "是";
          } 
        } 
        if (!ParameterUtils.isEmptyOrNull(dataOutDescobj.get("realborderdevId"))) {
          String[] devIdStr = dataOutDescobj.get("realborderdevId").toString().split(";");
          List<Long> idList = new ArrayList<>();
          for (int k = 0; k < devIdStr.length; k++) {
            Long devId = Long.valueOf(devIdStr[k].toString());
            idList.add(devId);
          } 
          dataOutDescobj.put("realborderdevIdDesc", descByQueryIdList(idList, Integer.valueOf(-1), Integer.valueOf(-1)));
        } else {
          dataOutDescobj.put("realborderdevIdDesc", "");
        } 
        if (!ParameterUtils.isEmptyOrNull(commentType)) {
          if (!ParameterUtils.isEmptyOrNull(resultIntvalue))
            if (resultIntvalue.intValue() == 0) {
              resultType = "处理成功";
            } else if (resultIntvalue.intValue() == 1) {
              resultType = "处理失败";
            } else if (resultIntvalue.intValue() == 2) {
              resultType = "误启动";
            } else if (resultIntvalue.intValue() == 3) {
              resultType = "定位准确";
            } else if (resultIntvalue.intValue() == 4) {
              resultType = "定位不准确";
            } else if (resultIntvalue.intValue() == 5) {
              resultType = "未启动";
            }  
        } else {
          dataOutDescobj.put("comMsg", "");
          dataOutDescobj.put("resultIntvalue", null);
        } 
        dataOutDescobj.put("faultTypeDesc", faultTypeDesc);
        dataOutDescobj.put("isFaultDesc", isFaultDesc);
        dataOutDescobj.put("faresultFlagDesc", faresultFlagDesc);
        dataOutDescobj.put("resultType", resultType);
        dataOutDescobj.put("waveFileList", "查看");
      } 
      Map<Object, List<Map<String, Object>>> mapDaFaultInftoDevEnergy = new HashMap<>();
      Integer pageIndex2 = Integer.valueOf(1);
      Integer pageSize2 = Integer.valueOf(-1);
      Map<Object, List<Map<String, Object>>> mapDaFaultInftoDevTrans = new HashMap<>();
      Integer pageIndex3 = Integer.valueOf(1);
      Integer pageSize3 = Integer.valueOf(-1);
      if (faultInfoID.size() > 0) {
        mapDaFaultInftoDevEnergy = loadFaultInfoEnergyAreaDev(faultInfoID, pageIndex2, pageSize2);
        mapDaFaultInftoDevTrans = loadFaultInfoTransAreaDev(faultInfoID, pageIndex3, pageSize3);
      } 
      for (int jm = 0; jm < faultDataInfoDesc.size(); jm++) {
        Map<String, Object> dataobj = faultDataInfoDesc.get(jm);
        Object key = dataobj.get("id");
        Object numEnergy = Integer.valueOf(0);
        Object numTrans = Integer.valueOf(0);
        List<Map<String, Object>> faultEnergy = new ArrayList<>();
        List<Map<String, Object>> faultTrans = new ArrayList<>();
        if (mapDaFaultInftoDevEnergy.containsKey(key)) {
          List<Map<String, Object>> objInfoEnergy = mapDaFaultInftoDevEnergy.get(key);
          numEnergy = Integer.valueOf(objInfoEnergy.size());
          faultEnergy = objInfoEnergy;
        } 
        if (mapDaFaultInftoDevTrans.containsKey(key)) {
          List<Map<String, Object>> objInfoTrans = mapDaFaultInftoDevTrans.get(key);
          numTrans = Integer.valueOf(objInfoTrans.size());
          faultTrans = objInfoTrans;
        } 
        dataobj.put("numEnergy", numEnergy);
        dataobj.put("numTrans", numTrans);
        dataobj.put("energyDetail", faultEnergy);
        dataobj.put("transDetail", faultTrans);
        Object recloseResultNum = dataobj.get("recloseResult");
        if (ParameterUtils.isEmptyOrNull(recloseResultNum))
          dataobj.put("daRecloseResult", "其他"); 
      } 
      page.setData(faultDataInfoDesc);
      if ("export".equals(paraVO.getMethod())) {
        String defectBranch = Constants.getString("dms.msg.proxy.handler.defect.branch", "");
        String columns = paraVO.getColumns();
        if (!defectBranch.equals("baoding"))
          columns = columns.replace(",{\"columnName\":\"isFaultDesc\",\"columnDescription\":\"故障是否属实\",\"align\":\"left\"},{\"columnName\":\"faultReason\",\"columnDescription\":\"供服返回结果\",\"align\":\"left\"}", ""); 
        if (!defectBranch.equals("wuxi") && !defectBranch.equals("anqing")) {
          columns = columns.replace("\"align\":\"left\"},{\"columnName\":\"realborderdevIdDesc\",\"columnDescription\":\"实际故障区域\",\"align\":\"left\"},{\"columnName\":\"faresultFlagDesc\",\"columnDescription\":\"是否定位准确\",", "").replace("\"align\":\"left\"},{\"columnName\":\"resultType\",\"columnDescription\":\"评价\",\"align\":\"left\"},{\"columnName\":\"comMsg\",\"columnDescription\":\"具体评价\",", "").replace("\"align\":\"left\"},{\"columnName\":\"configModeValue\",\"columnDescription\":\"当前故障处理模式\",", "").replace("\"align\":\"left\"},{\"columnName\":\"reduceNum\",\"columnDescription\":\"减少停电户数\",", "").replace("\"align\":\"left\"},{\"columnName\":\"reduceHournum\",\"columnDescription\":\"减少停电时户数\",", "");
          if (!defectBranch.equals("xiangyang"))
            columns = columns.replace("\"align\":\"left\"},{\"columnName\":\"areaDesc\",\"columnDescription\":\"单位\",", ""); 
        } 
        if (defectBranch.equals("wuxi"))
          columns = columns.replace("daRecloseResult", "daRecloseResultWx").replace("breakerName", "tripBreakerName"); 
        if (defectBranch.equals("anqing"))
          columns = columns.replace("{\"columnName\":\"areaDesc\",\"columnDescription\":\"单位\",\"align\":\"left\"},", "{\"columnName\":\"areaResp\",\"columnDescription\":\"所属区域\",\"align\":\"left\"},"); 
        List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        try {
          ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
        } catch (IOException e) {
          return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e.getMessage() }));
        } 
        return SmartView.FileView(outputStream, "故障信息列表文件.xls");
      } 
      return pageView(page);
    } 
    return SmartView.ERROR(I18n.message("error.parametertime.empty", "起始时间或者结束时间不能为空", new Object[] { "startTime,endTime" }));
  }
  
  @SmartComment("加载人工新增故障记录")
  public SmartView loadManualFaultInfoHistory(FaultInfoManualQueryParaVO paraVO) {
    if (!ParameterUtils.isEmptyOrNull(paraVO.getStartTime()) && !ParameterUtils.isEmptyOrNull(paraVO.getEndTime())) {
      PagingBean page = this.myDaFaultInfoService.loadManualFaultInfoHistory(paraVO);
      List<Long> idList = new ArrayList<>();
      for (Map<String, Object> map1 : (Iterable<Map<String, Object>>)page.getData()) {
        if (map1.get("comTypeValue").toString().equals("5"))
          map1.put("comType", "未启动"); 
        String tripTypeStr = "";
        if (!ParameterUtils.isEmptyOrNull(map1.get("tripType")))
          if (map1.get("tripType").toString().equals("1")) {
            tripTypeStr = "分级保护";
          } else if (map1.get("tripType").toString().equals("2")) {
            tripTypeStr = "站内跳闸";
          }  
        map1.put("tripTypeStr", tripTypeStr);
        Long id = null;
        if (!ParameterUtils.isEmptyOrNull(map1.get("breakerId")))
          id = Long.valueOf(map1.get("breakerId").toString()); 
        idList.add(id);
      } 
      List<Map<String, Object>> operationNoList = new ArrayList<>();
      if (idList.size() > 0)
        operationNoList = this.myDaFaultInfoService.loadOperationNoList(idList); 
      Map<Object, Map<String, Object>> map = new HashMap<>();
      for (Map<String, Object> operationMap : operationNoList)
        map.put(operationMap.get("id"), operationMap); 
      for (int i = 0; i < page.getData().size(); i++) {
        if (!ParameterUtils.isEmptyOrNull(((Map)page.getData().get(i)).get("breakerContainer")) && (
          (Map)page.getData().get(i)).get("breakerContainer").toString().equals("con_compositeswitch"))
          ((Map<String, String>)page.getData().get(i)).put("breakerName", (new StringBuilder()).append(((Map)map.get(((Map)page.getData().get(i)).get("breakerId"))).get("description")).append("/").append(((Map)page.getData().get(i)).get("breakerName")).append("-").append(((Map)map.get(((Map)page.getData().get(i)).get("breakerId"))).get("operationNo").toString().split("_")[0]).toString()); 
      } 
      if ("export".equals(paraVO.getMethod())) {
        String columns = paraVO.getColumns();
        List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        try {
          ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
        } catch (IOException e) {
          return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e.getMessage() }));
        } 
        return SmartView.FileView(outputStream, "非fa故障信息列表文件.xls");
      } 
      return pageView(page);
    } 
    return SmartView.ERROR(I18n.message("error.parametertime.empty", "起始时间或者结束时间不能为空", new Object[] { "startTime,endTime" }));
  }
  
  @SmartComment("将报告导出文本")
  public SmartView exportReport(String exportData) {
    List<Map<String, Object>> exportDataArray = JsonUtil.getMapListByJson(exportData);
    if (ParameterUtils.isEmptyOrNull(exportDataArray))
      return SmartView.ERROR("必须组织为JSONArray提交"); 
    String content = "";
    StringBuilder sfcontent = new StringBuilder();
    for (int k = 0; k < exportDataArray.size(); k++) {
      Map<String, Object> dataobj = exportDataArray.get(k);
      String title = String.valueOf(dataobj.get("title"));
      String contentdec = String.valueOf(dataobj.get("content"));
      sfcontent.append(title);
      sfcontent.append("\r\n");
      sfcontent.append(contentdec);
      sfcontent.append("\r\n");
    } 
    content = sfcontent.toString();
    try {
      ByteArrayInputStream inputStream = new ByteArrayInputStream(content.getBytes(Constants.UTF8));
      return SmartView.FileView(inputStream, "故障方案报告.txt");
    } catch (Exception e) {
      e.printStackTrace();
      return SmartView.ERROR(I18n.message("error.export.fa.text", "导出FA测试报告异常:{0}", new Object[] { e
              .getMessage() }));
    } 
  }
  
  public List<Integer> loadfaultDesc(Object faultNum) {
    List<Integer> daFaultTypevector = new ArrayList<>();
    String stringfault = faultNum.toString();
    int condNum = Integer.parseInt(stringfault);
    int b1 = condNum & 0x1;
    if (b1 > 0)
      daFaultTypevector.add(Integer.valueOf(b1)); 
    int b2 = condNum & 0x2;
    if (b2 > 0)
      daFaultTypevector.add(Integer.valueOf(b2)); 
    int b3 = condNum & 0x10;
    if (b3 > 0)
      daFaultTypevector.add(Integer.valueOf(b3)); 
    int b4 = condNum & 0x20;
    if (b4 > 0)
      daFaultTypevector.add(Integer.valueOf(b4)); 
    int b5 = condNum & 0x40;
    if (b5 > 0)
      daFaultTypevector.add(Integer.valueOf(b5)); 
    return daFaultTypevector;
  }
  
  public Map<Object, List<Map<String, Object>>> loadFaultInfoEnergyAreaDev(List<Object> faultInfoID, Integer pageIndex2, Integer pageSize2) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(faultInfoID))
      queryFilter.addNumberFieldInCondition("a.fault_id", faultInfoID); 
    Integer[] faultAreaTypes = { Integer.valueOf(1), Integer.valueOf(2), Integer.valueOf(3), Integer.valueOf(4) };
    List<Integer> faultAreaTypeList = (List<Integer>)Arrays.<Integer>stream(faultAreaTypes).distinct().collect(Collectors.toList());
    queryFilter.addNumberFieldInCondition("a.area_type", faultAreaTypeList);
    queryFilter.addStringFieldEqualCondition("obj_dev.filter", "energycustomer");
    queryFilter.addDateFieldLessEqualCondition("a.restore_time", DateUtil.getDate("2000-01-01 00:00:00"));
    queryFilter.setPageInfo(pageSize2, pageIndex2);
    PagingBean page = this.myDaFaultInfoService.queryareaEnergyDevRecords(queryFilter);
    List<Map<String, Object>> data = page.getData();
    List<Object> daFaultDevIdvector = new ArrayList();
    Map<Object, List<Map<String, Object>>> mapDaFaultInfoDesc = new HashMap<>();
    for (int i = 0; i < data.size(); i++) {
      Map<String, Object> tgAveObj = data.get(i);
      Object faultId = tgAveObj.get("faultId");
      if (!daFaultDevIdvector.contains(faultId)) {
        daFaultDevIdvector.add(faultId);
        List<Map<String, Object>> myInfo = new ArrayList<>();
        myInfo.add(tgAveObj);
        mapDaFaultInfoDesc.put(faultId, myInfo);
      } else {
        List<Map<String, Object>> myInfo = mapDaFaultInfoDesc.get(faultId);
        myInfo.add(tgAveObj);
        mapDaFaultInfoDesc.put(faultId, myInfo);
      } 
    } 
    List<Map<String, Object>> faultDataInfoDesc = new ArrayList<>();
    for (Object key : mapDaFaultInfoDesc.keySet()) {
      List<Map<String, Object>> objInfo = mapDaFaultInfoDesc.get(key);
      for (int j = 0; j < objInfo.size(); j++) {
        Map<String, Object> faultInfoDesc1 = objInfo.get(j);
        Object feederDesc = faultInfoDesc1.get("feederDesc");
        Object compositeswitchDesc = faultInfoDesc1.get("compositeswitchDesc");
        Object stationDesc = faultInfoDesc1.get("stationDesc");
        if (!ParameterUtils.isEmptyOrNull(feederDesc)) {
          faultInfoDesc1.put("upTableDevDesc", feederDesc);
        } else if (!ParameterUtils.isEmptyOrNull(compositeswitchDesc)) {
          faultInfoDesc1.put("upTableDevDesc", compositeswitchDesc);
        } else if (!ParameterUtils.isEmptyOrNull(stationDesc)) {
          faultInfoDesc1.put("upTableDevDesc", stationDesc);
        } else {
          faultInfoDesc1.put("upTableDevDesc", "");
        } 
      } 
    } 
    return mapDaFaultInfoDesc;
  }
  
  public Map<Object, List<Map<String, Object>>> loadFaultInfoTransAreaDev(List<Object> faultInfoID, Integer pageIndex2, Integer pageSize2) {
    QueryFilter queryFilter2 = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(faultInfoID))
      queryFilter2.addNumberFieldInCondition("a.fault_id", faultInfoID); 
    Integer[] faultAreaTypes = { Integer.valueOf(1), Integer.valueOf(2), Integer.valueOf(3), Integer.valueOf(4) };
    List<Integer> faultAreaTypeList = (List<Integer>)Arrays.<Integer>stream(faultAreaTypes).distinct().collect(Collectors.toList());
    queryFilter2.addNumberFieldInCondition("a.area_type", faultAreaTypeList);
    queryFilter2.addStringFieldEqualCondition("obj_dev.filter", "transwinding");
    queryFilter2.addDateFieldLessEqualCondition("a.restore_time", DateUtil.getDate("2000-01-01 00:00:00"));
    queryFilter2.setPageInfo(pageSize2, pageIndex2);
    PagingBean page2 = this.myDaFaultInfoService.queryareaTransDevRecords(queryFilter2);
    List<Map<String, Object>> data2 = page2.getData();
    List<Object> daFaultDevIdvector2 = new ArrayList();
    Map<Object, List<Map<String, Object>>> mapDaFaultInfoDesc2 = new HashMap<>();
    for (int im = 0; im < data2.size(); im++) {
      Map<String, Object> tgAveObj = data2.get(im);
      Object faultId = tgAveObj.get("faultId");
      if (!daFaultDevIdvector2.contains(faultId)) {
        daFaultDevIdvector2.add(faultId);
        List<Map<String, Object>> myInfo = new ArrayList<>();
        myInfo.add(tgAveObj);
        mapDaFaultInfoDesc2.put(faultId, myInfo);
      } else {
        List<Map<String, Object>> myInfo = mapDaFaultInfoDesc2.get(faultId);
        myInfo.add(tgAveObj);
        mapDaFaultInfoDesc2.put(faultId, myInfo);
      } 
    } 
    Map<Object, List<Map<String, Object>>> mapDaFaultInfoDescEnd = new HashMap<>();
    for (Object key : mapDaFaultInfoDesc2.keySet()) {
      List<Map<String, Object>> objInfo = mapDaFaultInfoDesc2.get(key);
      List<Object> daFaultTransFormerIdvector2 = new ArrayList();
      List<Map<String, Object>> myInfo = new ArrayList<>();
      for (int i = 0; i < objInfo.size(); i++) {
        Map<String, Object> faultInfoDesc1 = objInfo.get(i);
        Object feederDesc = faultInfoDesc1.get("feederDesc");
        Object compositeswitchDesc = faultInfoDesc1.get("compositeswitchDesc");
        Object stationDesc = faultInfoDesc1.get("stationDesc");
        Object transformerId = faultInfoDesc1.get("transformerId");
        faultInfoDesc1.put("upTableDevDesc", "");
        if (!ParameterUtils.isEmptyOrNull(feederDesc))
          faultInfoDesc1.put("upTableDevDesc", feederDesc); 
        if (!ParameterUtils.isEmptyOrNull(compositeswitchDesc))
          faultInfoDesc1.put("upTableDevDesc", compositeswitchDesc); 
        if (!ParameterUtils.isEmptyOrNull(stationDesc))
          faultInfoDesc1.put("upTableDevDesc", stationDesc); 
        if (!daFaultTransFormerIdvector2.contains(transformerId)) {
          daFaultTransFormerIdvector2.add(transformerId);
          myInfo.add(faultInfoDesc1);
        } 
      } 
      mapDaFaultInfoDescEnd.put(key, myInfo);
    } 
    return mapDaFaultInfoDescEnd;
  }
  
  public SmartView loadDescByQueryIdList(List<Long> idList, Integer pageIndex, Integer pageSize) {
    return SmartView.SUCCESS(descByQueryIdList(idList, pageIndex, pageSize));
  }
  
  public String descByQueryIdList(List<Long> idList, Integer pageIndex, Integer pageSize) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(idList))
      queryFilter.addNumberFieldInCondition("a.id", idList); 
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.myDaFaultInfoService.queryObjDevRecords(queryFilter);
    List<Map<String, Object>> data = page.getData();
    StringBuilder ieddevDesc = new StringBuilder("");
    int nVaildName = 0;
    Map<String, Object> broadMap = new LinkedHashMap<>(16);
    for (Long id : idList) {
      for (int j = 0; j < data.size(); j++) {
        Map<String, Object> tgAveObj = data.get(j);
        if (!ParameterUtils.isEmptyOrNull(tgAveObj.get("description").toString()) && 
          id.longValue() == Long.parseLong(tgAveObj.getOrDefault("id", "0").toString()))
          broadMap.put(tgAveObj.getOrDefault("id", "0").toString(), tgAveObj.get("description").toString()); 
      } 
    } 
    for (String id : broadMap.keySet()) {
      if (ParameterUtils.isEmptyOrNull(broadMap.get(id).toString()))
        continue; 
      if (nVaildName > 0)
        ieddevDesc.append("与"); 
      ieddevDesc.append(getDevNameWithFather(id));
      nVaildName++;
    } 
    if (nVaildName > 1)
      ieddevDesc.append("之间"); 
    if (nVaildName == 1)
      ieddevDesc.append("之后"); 
    return ieddevDesc.toString();
  }
  
  public String getDevNameWithFather(String devId) {
    String fullName = "未知";
    QueryFilter queryFilter = new QueryFilter();
    if (ParameterUtils.isNumeric(devId)) {
      Long devIdLong = Long.valueOf(Long.parseLong(devId));
      if (!ParameterUtils.isEmptyOrNull(devIdLong))
        queryFilter.addNumberFieldEqualCondition("e.id", devIdLong); 
    } 
    Integer pageIndex = Integer.valueOf(1);
    Integer pageSize = Integer.valueOf(-1);
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.myFaultEventService.queryConNameRecords("obj_dev", queryFilter);
    List<Map<String, Object>> data = page.getData();
    if (data.size() <= 0)
      return fullName; 
    Map<String, Object> tgAveObj = data.get(0);
    fullName = tgAveObj.get("description").toString();
    if (ParameterUtils.isEmptyOrNull(tgAveObj.get("containerTablename")))
      return fullName; 
    if (tgAveObj.get("containerTablename").toString() == "con_station")
      return fullName; 
    if (tgAveObj.get("containerTablename").toString() == "con_voltagelevel")
      return fullName; 
    if (ParameterUtils.isEmptyOrNull(tgAveObj.get("containerId")))
      return fullName; 
    Object containerId = tgAveObj.get("containerId");
    QueryFilter queryFilter2 = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(containerId))
      queryFilter2.addNumberFieldEqualCondition("e.id", containerId); 
    Integer pageIndex2 = Integer.valueOf(1);
    Integer pageSize2 = Integer.valueOf(-1);
    queryFilter2.setPageInfo(pageSize2, pageIndex2);
    PagingBean page2 = this.myFaultEventService.queryConNameRecords(tgAveObj
        .get("containerTablename").toString(), queryFilter2);
    List<Map<String, Object>> data2 = page2.getData();
    if (data2.size() <= 0)
      return fullName; 
    Map<String, Object> tgAveObj2 = data2.get(0);
    StringBuilder fullNameDesc = new StringBuilder("");
    if (!ParameterUtils.isEmptyOrNull(tgAveObj2.get("description")))
      fullNameDesc.append(tgAveObj2.get("description").toString()); 
    fullNameDesc.append(".");
    fullNameDesc.append(fullName);
    return fullNameDesc.toString();
  }
  
  public String queryBusbarFault(Long faultId) {
    String desc = "";
    QueryFilter queryFilter = new QueryFilter();
    queryFilter.addNumberFieldEqualCondition("a.fault_id", faultId);
    List<Integer> typeList = new ArrayList<>();
    typeList.add(Integer.valueOf(1));
    typeList.add(Integer.valueOf(2));
    queryFilter.addNumberFieldInCondition("a.area_type", typeList);
    List<Map<String, Object>> list = this.myDaFaultInfoService.queryFaultAreaDevInfoRecords(queryFilter).getData();
    if (list.size() > 0)
      for (int i = 0; i < list.size(); i++) {
        String filter = ((Map)list.get(i)).get("filter").toString();
        if (filter.equals("feedersegment")) {
          desc = "";
          break;
        } 
        if (filter.equals("busbar")) {
          desc = ((Map)list.get(i)).get("description").toString();
          String container = "";
          if (ParameterUtils.isEmptyOrNull(((Map)list.get(i)).get("containerId")) || ParameterUtils.isEmptyOrNull(((Map)list.get(i)).get("containerTablename"))) {
            container = "未知容器";
          } else {
            QueryFilter containerFilter = new QueryFilter();
            containerFilter.addNumberFieldEqualCondition("a.id", Long.valueOf(((Map)list.get(i)).get("containerId").toString()));
            container = ((Map)this.myDaFaultInfoService.loadContainer(containerFilter, ((Map)list.get(i)).get("containerTablename").toString()).getData().get(0)).get("description").toString();
          } 
          if (!ParameterUtils.isEmptyOrNull(container)) {
            desc = container + "." + desc;
          } else {
            desc = "未知容器." + desc;
          } 
          desc = desc + " 母线区段";
        } 
      }  
    return desc;
  }
  
  @SmartComment("Excel文件导入")
  public SmartView importFile(File file) {
    return SmartView.SUCCESS();
  }
  
  public String loadDaStartCondDesc(Object startCondNum) {
    StringBuilder da_faultstartcond_desc = new StringBuilder("");
    String stringCond = startCondNum.toString();
    int condNum = Integer.parseInt(stringCond);
    int b1 = condNum & 0x2;
    if (b1 > 0)
      da_faultstartcond_desc.append("  非正常分闸"); 
    int b2 = condNum & 0x4;
    if (b2 > 0)
      da_faultstartcond_desc.append("  分闸加事故总"); 
    int b3 = condNum & 0x8;
    if (b3 > 0)
      da_faultstartcond_desc.append("  分闸加保护动作"); 
    int b4 = condNum & 0x40;
    if (b4 > 0)
      da_faultstartcond_desc.append("  分合分"); 
    int b5 = condNum & 0x80;
    if (b5 > 0)
      da_faultstartcond_desc.append("  分闸加纵差保护"); 
    return da_faultstartcond_desc.toString();
  }
  
  public String loadDaFaultTypeDesc(Object faultType) {
    StringBuilder da_faultType_desc = new StringBuilder("");
    List<Object> faultTypeInfoDesc = new ArrayList();
    faultTypeInfoDesc = (ArrayList)faultType;
    int b1 = faultTypeInfoDesc.indexOf(Integer.valueOf(1));
    if (b1 > -1)
      da_faultType_desc.append("永久故障    "); 
    int b2 = faultTypeInfoDesc.indexOf(Integer.valueOf(2));
    if (b2 > -1)
      da_faultType_desc.append("瞬时故障    "); 
    int b3 = faultTypeInfoDesc.indexOf(Integer.valueOf(16));
    if (b3 > -1)
      da_faultType_desc.append("短路故障    "); 
    int b4 = faultTypeInfoDesc.indexOf(Integer.valueOf(32));
    if (b4 > -1)
      da_faultType_desc.append("单相接地故障  "); 
    int b5 = faultTypeInfoDesc.indexOf(Integer.valueOf(64));
    if (b5 > -1) {
      String defectBranch = Constants.getString("dms.msg.proxy.handler.defect.branch", "");
      if (defectBranch.equals("baoding")) {
        da_faultType_desc.append("疑似过流故障  ");
      } else {
        da_faultType_desc.append("疑似故障  ");
      } 
    } 
    int b6 = faultTypeInfoDesc.indexOf(Integer.valueOf(-1));
    if (b6 > -1)
      da_faultType_desc.append("正常  "); 
    return da_faultType_desc.toString();
  }
  
  public SmartView loadFaultAreaDevInfo(Long faultId, List<Long> faultAreaTypeList, Integer pageIndex, Integer pageSize) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(faultId))
      queryFilter.addNumberFieldEqualCondition("a.fault_id", faultId); 
    if (!ParameterUtils.isEmptyOrNull(faultAreaTypeList))
      queryFilter.addNumberFieldInCondition("a.area_type", faultAreaTypeList); 
    if (pageSize == null || pageIndex == null)
      return SmartView.ERROR(I18n.message("error.parameter.empty", "分页参数{0}不能为空", new Object[] { "pageIndex,pageSize" })); 
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.myDaFaultInfoService.queryFaultAreaDevInfoRecords(queryFilter);
    return pageView(page);
  }
  
  @SmartComment("查询FA投运记录")
  public SmartView loadFaRecord(FaultInfoQueryParaVO paraVO) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(paraVO.getFaultMode()))
      queryFilter.addNumberFieldInCondition("a.fault_mode", paraVO.getFaultMode()); 
    if (!ParameterUtils.isEmptyOrNull(paraVO.getDaStatus()))
      queryFilter.addNumberFieldInCondition("a.run_state", paraVO.getDaStatus()); 
    if (paraVO.getPageSize() == null || paraVO.getPageIndex() == null)
      return SmartView.ERROR(I18n.message("error.parameter.empty", "分页参数{0}不能为空", new Object[] { "pageIndex,pageSize" })); 
    queryFilter.setPageInfo(paraVO.getPageSize(), paraVO.getPageIndex());
    PagingBean page = this.myDaFaultInfoService.queryFaRecords(queryFilter, paraVO.getContainerId(), paraVO.getContainerName(), paraVO.getOrgId(), paraVO.getLevel());
    if ("export".equals(paraVO.getMethod())) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(paraVO.getColumns(), HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e.getMessage() }));
      } 
      return SmartView.FileView(outputStream, "FA投运记录列表文件.xls");
    } 
    return pageView(page);
  }
  
  @SmartComment("保存fa评价信息")
  public SmartView savaFaComment(Map<String, Object> faComment) {
    if (this.myDaFaultInfoService.saveFaComment(faComment).equals("success"))
      return SmartView.SUCCESS(); 
    return SmartView.ERROR("保存fa评价信息失败！");
  }
  
  @SmartComment("加载线路")
  public SmartView loadFeeders(String description) {
    return SmartView.PAGEDATA(this.myDaFaultInfoService.loadFeeders(description));
  }
  
  @SmartComment("编辑人工故障")
  public SmartView saveManualFaultInfo(Map<String, Object> manualFaultInfo) {
    if (manualFaultInfo.get("mode").toString().equals("add")) {
      if (this.myDaFaultInfoService.saveManualFaultInfo(manualFaultInfo).equals("success"))
        return SmartView.SUCCESS(); 
      return SmartView.ERROR("新建故障失败！");
    } 
    if (this.myDaFaultInfoService.saveManualComment(manualFaultInfo).equals("success"))
      return SmartView.SUCCESS(); 
    return SmartView.ERROR("保存人工故障评价信息失败！");
  }
  
  @SmartComment("删除人工故障")
  public SmartView delManualFault(Long faultId) {
    if (this.myDaFaultInfoService.delManualFault(faultId).equals("success"))
      return SmartView.SUCCESS(); 
    return SmartView.ERROR("删除故障失败！");
  }
  
  @SmartComment("加载责任区列表")
  public SmartView loadAreaDesc() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadAreaDesc());
  }
  
  @SmartComment("加载开关")
  public SmartView loadBreakers(Integer type, Long feederId, String description) {
    PagingBean page = this.myDaFaultInfoService.loadBreakers(type, feederId, description);
    return SmartView.PAGEDATA(page);
  }
  
  @SmartComment("加载开关")
  public SmartView loadBreakersByComSwitch(Long comSwitch) {
    List<Map<String, Object>> list = this.myDaFaultInfoService.loadBreakersByComSwitch(comSwitch);
    return SmartView.SUCCESS(list);
  }
  
  @SmartComment("加载环网柜")
  public SmartView loadComSwitch(String description) {
    PagingBean page = this.myDaFaultInfoService.loadComSwitch(description);
    return SmartView.PAGEDATA(page);
  }
  
  @SmartComment("加载跳闸情况选项")
  public SmartView loadTripArray() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadTripArray());
  }
  
  @SmartComment("加载故障录波列表")
  public SmartView loadWaveFileList(Long faultId) {
    if (ParameterUtils.isEmptyOrNull(faultId))
      return SmartView.ERROR("FaultId为空"); 
    return SmartView.PAGEDATA(this.myDaFaultInfoService.loadWaveFileList(faultId));
  }
  
  @SmartComment("加载当前故障处理模式")
  public SmartView loadFaLocalDms() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFaLocalDms());
  }
  
  @SmartComment("加载馈线列表")
  public SmartView loadFeederList(FaultAutoCheckQueryParaVO paraVO) {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFeederList(paraVO));
  }
  
  @SmartComment("馈线FA巡检结果列表")
  public SmartView loadFaFeederAutoCheckList(FaultAutoCheckQueryParaVO paraVO) {
    PagingBean page = this.myDaFaultInfoService.loadFaFeederAutoCheck(paraVO);
    List<Map<String, Object>> data = page.getData();
    List<Map<String, Object>> newtypedata = new ArrayList<>();
    if (!ParameterUtils.isEmptyOrNull(paraVO.getFaCheckFderrtype())) {
      if (paraVO.getFaCheckFderrtype().size() != 0) {
        for (int k = 0; k < data.size(); k++) {
          Map<String, Object> tgAveObj = data.get(k);
          Object objtype = tgAveObj.get("errType");
          if (!ParameterUtils.isEmptyOrNull(objtype) && 
            multiSelectionFiltration(objtype, paraVO.getFaCheckFderrtype()))
            newtypedata.add(tgAveObj); 
        } 
      } else {
        newtypedata.addAll(data);
      } 
    } else {
      newtypedata.addAll(data);
    } 
    page.setData(newtypedata);
    PagingBean pagingBean = null;
    if (page.getData().size() == 0) {
      pagingBean = new PagingBean(paraVO.getPageSize().intValue(), paraVO.getPageIndex().intValue(), page.getData());
      pagingBean.setTotalItems(page.getData().size());
    } else if (paraVO.getPageIndex().intValue() > 0) {
      List<List<Map<String, Object>>> rawDataListList = ListUtil.split(page.getData(), paraVO.getPageSize().intValue());
      List<Map<String, Object>> rawDataList = rawDataListList.get(paraVO.getPageIndex().intValue() - 1);
      pagingBean = new PagingBean(paraVO.getPageSize().intValue(), paraVO.getPageIndex().intValue(), rawDataList);
      pagingBean.setTotalItems(page.getData().size());
    } else {
      pagingBean = new PagingBean(paraVO.getPageSize().intValue(), paraVO.getPageIndex().intValue(), page.getData());
      pagingBean.setTotalItems(page.getData().size());
    } 
    if ("export".equals(paraVO.getMethod())) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(paraVO.getColumns(), HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(pagingBean.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e.getMessage() }));
      } 
      return SmartView.FileView(outputStream, "FA馈线巡检结果.xls");
    } 
    return SmartView.PAGEDATA(pagingBean);
  }
  
  @SmartComment("开关FA巡检结果列表")
  public SmartView loadFaBreakerAutoCheckList(FaultAutoCheckQueryParaVO paraVO) {
    List<Map<String, Object>> list = this.myDaFaultInfoService.loadFaBreakerAutoCheck(paraVO);
    if ("export".equals(paraVO.getMethod())) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(paraVO.getColumns(), HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(list, headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e.getMessage() }));
      } 
      return SmartView.FileView(outputStream, "FA开关巡检结果.xls");
    } 
    return SmartView.SUCCESS(list);
  }
  
  @SmartNoSecurityFilter
  @SmartComment("查询开关具体量测信息")
  public SmartView loadBreakerValueList(Long breakerId) {
    List<Map<String, Object>> list = this.myDaFaultInfoService.loadBreakerValueList(breakerId);
    return SmartView.SUCCESS(list);
  }
  
  public String loadDaOperTarget(Object daOperTarget, List<Integer> daOperTargetList) {
    if (ParameterUtils.isEmptyOrNull(daOperTarget))
      return "0"; 
    StringBuilder da_faultstartcond_desc = new StringBuilder("");
    String stringType = daOperTarget.toString();
    int typeNum = Integer.parseInt(stringType);
    String tagname = "0";
    for (int i = 0; i < daOperTargetList.size(); i++) {
      Integer typetag = daOperTargetList.get(i);
      if (typetag.intValue() != -1) {
        int b1 = typeNum & 1 << typetag.intValue();
        if (b1 > 0) {
          tagname = "1";
          break;
        } 
      } 
    } 
    return tagname;
  }
  
  @SmartComment("加载FA执行方式")
  public SmartView loadFaModeDms() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFaModeDms());
  }
  
  @SmartComment("加载运行状态")
  public SmartView loadDaRunningStatus() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadDaRunningStatus());
  }
  
  @SmartComment("加载馈线自愈巡检异常类型")
  public SmartView loadFaCheckFderrtype() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFaCheckFderrtype());
  }
  
  @SmartComment("加载馈线组信息")
  public SmartView loadFeederGroup() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFeederGroup());
  }
  
  @SmartComment("加载馈线类型")
  public SmartView loadFeederObjType() {
    return SmartView.SUCCESS(this.myDaFaultInfoService.loadFeederObjTypeList());
  }
  
  public boolean multiSelectionFiltration(Object actualValue, List<Integer> multiMenuSelections) {
    StringBuilder da_faultstartcond_desc = new StringBuilder("");
    String stringType = actualValue.toString();
    int typeNum = Integer.parseInt(stringType);
    boolean isMultiSelection = false;
    for (int i = 0; i < multiMenuSelections.size(); i++) {
      Integer typetag = multiMenuSelections.get(i);
      if (typetag.intValue() != -1) {
        int b1 = typeNum & 1 << typetag.intValue();
        if (b1 > 0) {
          isMultiSelection = true;
          break;
        } 
      } 
    } 
    return isMultiSelection;
  }
}
